/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// identities - Array of bridge IDs.    bridgesSubscriptions - CallMediaSubscriptions parameter block.
    /// </summary>
    [DataContract]
        public partial class BridgesSubscribeParams :  IEquatable<BridgesSubscribeParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BridgesSubscribeParams" /> class.
        /// </summary>
        /// <param name="identities">identities.</param>
        /// <param name="bridgesSubscriptions">bridgesSubscriptions.</param>
        public BridgesSubscribeParams(List<string> identities = default(List<string>), BridgesSubscriptions bridgesSubscriptions = default(BridgesSubscriptions))
        {
            this.Identities = identities;
            this.BridgesSubscriptions = bridgesSubscriptions;
        }
        
        /// <summary>
        /// Gets or Sets Identities
        /// </summary>
        [DataMember(Name="identities", EmitDefaultValue=false)]
        public List<string> Identities { get; set; }

        /// <summary>
        /// Gets or Sets BridgesSubscriptions
        /// </summary>
        [DataMember(Name="bridgesSubscriptions", EmitDefaultValue=false)]
        public BridgesSubscriptions BridgesSubscriptions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BridgesSubscribeParams {\n");
            sb.Append("  Identities: ").Append(Identities).Append("\n");
            sb.Append("  BridgesSubscriptions: ").Append(BridgesSubscriptions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BridgesSubscribeParams);
        }

        /// <summary>
        /// Returns true if BridgesSubscribeParams instances are equal
        /// </summary>
        /// <param name="input">Instance of BridgesSubscribeParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BridgesSubscribeParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Identities == input.Identities ||
                    this.Identities != null &&
                    input.Identities != null &&
                    this.Identities.SequenceEqual(input.Identities)
                ) && 
                (
                    this.BridgesSubscriptions == input.BridgesSubscriptions ||
                    (this.BridgesSubscriptions != null &&
                    this.BridgesSubscriptions.Equals(input.BridgesSubscriptions))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Identities != null)
                    hashCode = hashCode * 59 + this.Identities.GetHashCode();
                if (this.BridgesSubscriptions != null)
                    hashCode = hashCode * 59 + this.BridgesSubscriptions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
